<?php 
/***************************************/
/* Script eedomus_worldweatheronline   */
/***************************************/



if (isset($_GET['k'])) 
{
	$key = $_GET['k'];
	if (isset($_GET['c'])) 
	{
		$commune = $_GET['c'];
		$url = "http://api.worldweatheronline.com/free/v1/weather.ashx?q=".$commune."&format=xml&num_of_days=2&key=".$key;
		
		// L'API est limit en nombre de requtes par secondes.
		// Pour pallier  cela, on stocke le XML pour 8 secondes (ce qui fait moins de 500 appels/h)
		// et on pioche dedans plutt que d'avoir  utiliser l'API
		if (time() + 8 > loadVariable('wwo_timestamp'))
		{
			$xml = httpQuery($url);
		
			$output = '<?xml version="1.0" encoding="UTF-8"?>';
			$output .= '<meteo>';
			$output .= '<aujourdhui>';
			$output .= sdk_xml_format($xml,0);
			$output .= '</aujourdhui>';
			$output .= '<demain>';
			$output .= sdk_xml_format($xml,1);
			$output .= '</demain>';
			$output .= '</meteo>';
			echo $output;
			
			saveVariable('wwo_timestamp',time());
			saveVariable('wwo_xml',$output);
		}
		else
			echo loadVariable('wwo_xml');
	}
	else
		die("Erreur: Vous devez prciser votre commune en appelant ce script");
}	
else 
	die("Erreur: Vous devez prciser votre cl API WorldWeatherOnline en appelant ce script");

	
function sdk_xml_format($xml,$decalage)
{
	$decalage ++;
	// Formate les donnes mto

	$out = '<tempMax>'.xpath($xml,'/data/weather['.$decalage.']/tempMaxC').'</tempMax>';
	$out .= '<tempMin>'.xpath($xml,'/data/weather['.$decalage.']/tempMinC').'</tempMin>';
	$out .= '<ventVitesse>'.xpath($xml,'/data/weather['.$decalage.']/windspeedKmph').'</ventVitesse>';
	$out .= '<ventDirection>'.xpath($xml,'/data/weather['.$decalage.']/winddirection').'</ventDirection>';
	$out .= '<ventDirDegres>'.xpath($xml,'/data/weather['.$decalage.']/winddirDegree').'</ventDirDegres>';
	$out .= '<codeTemps>'.xpath($xml,'/data/weather['.$decalage.']/weatherCode').'</codeTemps>';
	$out .= '<iconeTemps>'.xpath($xml,'/data/weather['.$decalage.']/weatherIconUrl').'</iconeTemps>';
	$out .= '<precipitations>'.xpath($xml,'/data/weather['.$decalage.']/precipMM').'</precipitations>';

	return $out;
}
?>